<?php

class Ajw_member_import_CP {

	var $version = '1.0';
	var $module_name = "Ajw_member_import";

	function Ajw_member_import_CP( $switch = TRUE )
	{
		global $IN, $DB, $DSP;

		// Upgrade module if necessary
		$query = $DB->query( "SELECT module_version FROM exp_modules WHERE module_name = '" . $this->module_name . "'" );
		if( $query->num_rows > 0 ) {
			if( $query->row['module_version'] != $this->version )
			{
				$DB->query("UPDATE exp_modules SET module_version='".$this->version."' WHERE module_name='" . $this->module_name . "'");
			}
		}

		ini_set('auto_detect_line_endings', true);

		if ( $switch ) {
			switch($IN->GBL('P'))
			{
				
				case "check_details":
				$this->check_details();
				break;
				
				case "map_fields":
				$this->map_fields();
				break;
				
				case "import":
				$this->import();
				break;
				
				case "results":
				$this->results();
				break;

				default:
				$this->home();
				break;
			}
		}

	}
	// END


	function home() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		$r = "";
		
		$DSP->title = $LANG->line('ajw_member_import_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=' . $this->module_name,
			$LANG->line('ajw_member_import_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Select File");    

		$DSP->right_crumb( "Documentation", "http://brandnewbox.co.uk/docs/");

		$DSP->crumbline = TRUE;

		$DSP->extra_header .= '<link rel="stylesheet" type="text/css" media="screen" href="/' . $PREFS->ini("system_folder", TRUE) . 'modules/ajw_member_import/css/ajw_member_import.css" ></link>';

		$r .= $this->_header( $LANG->line('ajw_member_import_module_name') );
		$r .= $this->_stepper();

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=check_details', 
				'enctype' => "multipart/form-data", 
				'name' => 'apply', 
				'id' => 'apply'
			)
		);

		$r .= $DSP->qdiv(
			'tableHeading', 
			"File Details"
		);

		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$i = 0;

		// File location
		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->table_qcell(
			$style, 
			$DSP->qspan('alert', '* ') . 
			$DSP->qspan('defaultBold', 'File') .
			$DSP->qdiv('default', "Select the location of the CSV file to use. The location is relative to your control panel folder, eg, ../members.csv, when placed at the site root"), 
			'25%', 'center');
		$r .= $DSP->table_qcell(
			$style, 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('file', '', '64', '', 'input', ''),
				'70%'
				)
			),
			'75%'
		);
		$r .= $DSP->tr_c();

		// Delimiter
		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->table_qcell(
			$style, 
			$DSP->qspan('alert', '* ') . 
			$DSP->qspan('defaultBold', 'Delimiter') .
			$DSP->qdiv('default', "Usually a comma or tab (\\t)"), 
			'', 'center');
		$r .= $DSP->table_qcell(
			$style, 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
						$DSP->input_select_header( "delimiter" ) .
						$DSP->input_select_option( ",", "Comma" ) .
						$DSP->input_select_option( 'TAB', "Tab" ) .
						$DSP->input_select_option( ':', "Colon" ) .
						$DSP->input_select_footer() . 
					" or other: " .
					$DSP->input_text('alt_delimiter', '', '8', '', 'input', ''),
				'70%'
				)
			),
			'50%'
		);
		$r .= $DSP->tr_c();
		
		// Encloser
		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->table_qcell(
			$style, 
			$DSP->qspan('alert', '* ') . 
			$DSP->qspan('defaultBold', 'Encloser') .
			$DSP->qdiv('default', "Usually a \" or similar. If you have no encloser use a \" and the importer will handle it"), 
			'', 'center');
		$r .= $DSP->table_qcell(
			$style, 
			$DSP->qdiv('defaultBold', 
				$DSP->qdiv('itemWrapper', 
					$DSP->input_text('encloser', '', '8', '', 'input', ''),
				'70%'
				)
			),
			'50%'
		);
		$r .= $DSP->tr_c();
		
		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', 
			$DSP->qspan('alert', '* ') .
			$DSP->qspan('default', 'indicates required fields') 
			);

		$r .= $DSP->input_submit("Submit");

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}

	function check_details() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Handle input
		$this->_set_session( "file", $IN->GBL( "file" ) );
		$file = $IN->GBL( "file" );
		
		$handle = @fopen($file, "r");
		if ( $handle === FALSE ) {
			$DSP->body .= $DSP->error_message("File cannot be opened.");        
			return;
		}
		
		$delimiter = $IN->GBL( "delimiter" );
		if ( $IN->GBL("alt_delimiter") != "" ) {
			$delimiter = $IN->GBL("alt_delimiter");
		}
		if ( $delimiter == "TAB" ) {
			$delimiter = "\t";
		}
		$this->_set_session( "delimiter", $delimiter );
		
		$encloser = stripslashes($IN->GBL( "encloser" ));
		if ( $encloser == "" ) { 
			$encloser = '"'; 
		}
		if ( $IN->GBL("alt_encloser") != "" ) {
			$encloser = $IN->GBL("alt_encloser");
		}
		$this->_set_session( "encloser", $encloser );

		$item = fgetcsv($handle, 10000, $delimiter, $encloser);
		rewind($handle);

		$r = "";
		
		$DSP->title = $LANG->line('ajw_member_import_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=' . $this->module_name,
			$LANG->line('ajw_member_import_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Check details");    

		$DSP->right_crumb( "Documentation", "http://brandnewbox.co.uk/docs/");

		$DSP->crumbline = TRUE;

		$DSP->extra_header .= '<link rel="stylesheet" type="text/css" media="screen" href="/' . $PREFS->ini("system_folder", TRUE) . 'modules/ajw_member_import/css/ajw_member_import.css" ></link>';

		$r .= $this->_header( $LANG->line('ajw_member_import_module_name') );
		$r .= $this->_stepper();

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=map_fields', 
				'enctype' => "multipart/form-data", 
				'name' => 'apply', 
				'id' => 'apply'
			)
		);

		$no_columns = count( $item );

		if ( $no_columns == 1 ) {
			$r .= $DSP->div("box") . "You have only 1 column - check the delimiter" . $DSP->div_c();
		}

		$s = $DSP->qdiv(
			'tableHeading', 
			"Check Details"
		);

		$s .= $DSP->table('tableBorder', '0', '0', '100%');

		$s .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', count($item) ) . 
			'Preview of the first few lines' .
			$DSP->td_c();
		$s .= $DSP->tr_c();

		$i = 0;
		$column_warning = FALSE;
		while (($item = fgetcsv($handle, 10000, $delimiter, $encloser)) !== FALSE) {
			$s .= $DSP->tr();

			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			for( $j=0; $j<count($item); $j++ ) {
				$s .= $DSP->table_qcell($style, $item[$j]);
			}

			$s .= $DSP->tr_c();

			if ( $no_columns != count( $item ) ) {
				$column_warning = TRUE;
			}

			if( $i > 5 ) break;
			
		}

		$s .= $DSP->table_c();

		if ( $column_warning ) {
			$r .= $DSP->div("box") . "Some rows have a different number of columns - check the delimiter and encloser" . $DSP->div_c();
		}


		$r .= $s;

		$r .= $DSP->qdiv('itemWrapper', 
			$DSP->qspan('alert', '* ') .
			$DSP->qspan('default', 'indicates required fields') 
			);

		$r .= $DSP->qdiv('default alert', 
		$DSP->input_checkbox('skip', 'y') . 
		"Skip first line of file on import?"
		) .BR;


		$r .= $DSP->input_submit("Proceed");

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}


	function map_fields() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN;

		// Handle input
		$file = $this->_get_session( "file", TRUE );
		$handle = fopen($file, "r");  

		$delimiter = $this->_get_session( "delimiter", TRUE );
		$encloser = stripslashes($this->_get_session( "encloser", TRUE ));

		$item = fgetcsv($handle, 10000, $delimiter, $encloser);

		$this->_set_session( "skip", $IN->GBL( "skip" ) );

		$select = "";
		$select .= $DSP->input_select_option( "", "none" );
		$select .= $DSP->input_select_option( "", "-----" );
		for( $j=0; $j<count($item); $j++ ) {
			$select .= $DSP->input_select_option( $j, $item[$j]);
		}

		$r = "";

		$DSP->title = $LANG->line('ajw_member_import_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=' . $this->module_name,
			$LANG->line('ajw_member_import_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Map member fields");    

		$DSP->right_crumb( "Documentation", "http://brandnewbox.co.uk/docs/");

		$DSP->crumbline = TRUE;

		$DSP->extra_header .= '<link rel="stylesheet" type="text/css" media="screen" href="/' . $PREFS->ini("system_folder", TRUE) . 'modules/ajw_member_import/css/ajw_member_import.css" ></link>';

		$r .= $this->_header( $LANG->line('ajw_member_import_module_name') );
		$r .= $this->_stepper();

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=import', 
				'enctype' => "multipart/form-data", 
				'name' => 'apply', 
				'id' => 'apply'
			)
		);

		$r .= $DSP->qdiv(
			'tableHeading', 
			"Map members fields to CSV fields"
		);

		$r .= $DSP->table('tableBorder', '0', '0', '100%');


		$i = 0;

		// Mandatory fields

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', count($item) ) . 
			'Mandatory fields' .
			$DSP->td_c();
		$r .= $DSP->tr_c();

		$fields = array(
			"username" => "Username",
			"screen_name" => "Screen Name"
		);
		
		foreach( $fields as $key => $field ) {

			$r .= $DSP->tr();

			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->table_qcell($style, 
				$DSP->qspan('alert', '* ') . 
				$DSP->qspan('defaultBold', $field ),
				'30%'
			);

			$r .= $DSP->table_qcell($style, 
				$DSP->input_select_header( $key ) .
				$select .
				$DSP->input_select_footer(),
				'65%'
			);

			$r .= $DSP->tr_c();
		}

		// Groups		
		$r .= $DSP->tr();

		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

		$r .= $DSP->table_qcell($style, 
			$DSP->qspan('alert', '* ') . 
			$DSP->qspan('defaultBold', "Member Group")
		);

		$query = $DB->query("SELECT * FROM exp_member_groups");
		$groups = "";
		foreach( $query->result as $row ) {
			$groups .= $DSP->input_select_option( $row["group_id"], $row["group_title"], $row["group_title"] == "Members" ? 'y' : '' );
		}

		$r .= $DSP->table_qcell($style, 
			$DSP->input_select_header( "group_id" ) .
			$groups .
			$DSP->input_select_footer()
		);

		$r .= $DSP->tr_c();

		// Email

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', count($item) ) . 
			'Email address' .
			$DSP->td_c();
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();

		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

		$r .= $DSP->table_qcell($style, 
			$DSP->qspan('alert', '* ') . 
			$DSP->qspan('defaultBold', "Email address" ),
			'30%'
		);

		$r .= $DSP->table_qcell($style, 
			$DSP->input_select_header( "email" ) .
			$select .
			$DSP->input_select_footer(),
			'65%'
		);

		$r .= $DSP->tr_c();
		
		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

		$r .= $DSP->table_qcell($style, 
			$DSP->qspan('defaultBold', "Fallback email address") .
			$DSP->qdiv('default', "Use this value if no email address is defined. You can also use the variables {username} and {row} to generate a unique email, eg, dummy{row}@yourdomain.com")
		);

		$r .= $DSP->table_qcell($style, 
			$DSP->input_text('fallback_email', '', '64', '', 'input', '')
		);
		$r .= $DSP->tr_c();

		// Password

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', count($item) ) . 
			'Password details' .
			$DSP->td_c();
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

		$r .= $DSP->table_qcell($style, 
			$DSP->qspan('defaultBold', "Password") .
			$DSP->qdiv('default', "If set to 'none', a random password will be generated")
		);

		$r .= $DSP->table_qcell($style, 
			$DSP->input_select_header( "password" ) .
			$select .
			$DSP->input_select_footer()
		);
		$r .= $DSP->tr_c();

		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

		$r .= $DSP->table_qcell($style, 
			$DSP->qspan('defaultBold', "Password is in plain text") .
			$DSP->qdiv('default', "Is the password in supplied plain text (ie, not encrypted)? Plain text passwords will be encrypted, or you can import pre-encrpyted MD5 or SHA passwords")
		);

		$r .= $DSP->table_qcell($style, 
			$DSP->input_select_header( "password_plaintext" ) .
			$DSP->input_select_option( "y", "Yes" ) .
			$DSP->input_select_option( "n", "No" ) .
			$DSP->input_select_footer()
		);
		$r .= $DSP->tr_c();

		// Custom fields

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', count($item) ) . 
			'Custom member fields' .
			$DSP->td_c();
		$r .= $DSP->tr_c();

		$query = $DB->query("SELECT * FROM exp_member_fields");
		foreach( $query->result as $row ) {

			$r .= $DSP->tr();

			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->table_qcell($style, 
				$DSP->qspan('defaultBold', $row["m_field_label"]) .
				$DSP->qdiv('default', $row["m_field_description"])
			);

			$r .= $DSP->table_qcell($style, 
				$DSP->input_select_header( "m_field_" . $row["m_field_id"] ) .
				$select .
				$DSP->input_select_footer()
			);

			$r .= $DSP->tr_c();
		}

		// Other fields

		$r .= $DSP->tr() .
			$DSP->td('tableHeadingAlt', '', count($item) ) . 
			'Built in fields' .
			$DSP->td_c();
		$r .= $DSP->tr_c();

		$fields = array(
			"url" => "URL",
			"location" => "Location",
			"bio" => "Bio"
		);
		
		foreach( $fields as $key => $field ) {

			$r .= $DSP->tr();

			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->table_qcell($style, 
				$DSP->qspan('defaultBold', $field )
			);

			$r .= $DSP->table_qcell($style, 
				$DSP->input_select_header( $key ) .
				$select .
				$DSP->input_select_footer()
			);

			$r .= $DSP->tr_c();
		}

		$r .= $DSP->table_c();

		$r .= $DSP->qdiv('itemWrapper', 
			$DSP->qspan('alert', '* ') .
			$DSP->qspan('default', 'indicates required fields') 
			);

		$r .= $DSP->input_submit("Proceed");

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}


	function import() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN, $FNS;

		// Handle input
		if( $IN->GBL("email") == "" && $IN->GBL("fallback_email") == "" ) {
			$DSP->body .= $DSP->error_message("Email field must be selected.");        
      return;
		}
		if( $IN->GBL("username") == "" ) {
			$DSP->body .= $DSP->error_message("Username field must be selected.");        
      return;
		}
		if( $IN->GBL("screen_name") == "" ) {
			$DSP->body .= $DSP->error_message("Screen Name field must be selected.");        
      return;
		}
		if( $IN->GBL("group_id") == "" ) {
			$DSP->body .= $DSP->error_message("Member Group field must be selected.");        
      return;
		}

		// Get member fields
		$member_fields = array("screen_name", "username", "email", "password", "url", "location", "bio");
		$members = array();
		foreach( $member_fields as $field ) {
			if( $IN->GBL( $field) != "" ) {
				$members[ $field ] = $IN->GBL( $field );
			} 
		}
		
		// Get custom data
		$member_data = array();
		$query = $DB->query("SELECT * FROM exp_member_fields");
		foreach( $query->result as $row ) {
			if( $IN->GBL( "m_field_".$row["m_field_id"] ) != "" ) {
				$member_data[ "m_field_id_".$row["m_field_id"] ] = $IN->GBL( "m_field_".$row["m_field_id"] );
			}			
		}

		$group_id = $IN->GBL( "group_id" );
		$plaintext = $IN->GBL( "password_plaintext" );

		$file = $this->_get_session( "file", TRUE );
		$handle = fopen($file, "r");  

		$delimiter = $this->_get_session( "delimiter", TRUE );
		$encloser = stripslashes($this->_get_session( "encloser", TRUE ));
		$skip = $this->_get_session("skip", TRUE);

		// Do import 
		
		$count = 0;
		$imported = 0;
		$output = array();
		$errors = array();
		while (($item = fgetcsv($handle, 10000, $delimiter, $encloser)) !== FALSE) {
		
			if ( ++$count == 1 ) {
				if ( $skip == "y" ) {
					continue;
				}
			}

			if ( ! class_exists('Validate'))
			{
				require PATH_CORE.'core.validate'.EXT;
			}
	
			// Check whether email address exists in the members table
			
			/*
			$email = $item[ $members["email"] ];
			$sql = "SELECT email FROM exp_members WHERE email = '" . $email . "'";
			$query = $DB->query( $sql );
			if ( $query->num_rows > 0 ) {
				$errors[ $email ] = "Email " . $email . " already exixts";
				continue;
			}
			*/
			
			// Insert member data into exp_members
			
			$data = array();
			foreach( $members as $field => $mapping ) {
				$data[ $field ] = $item[ $mapping ];
			}
			$data['group_id'] = $group_id;
			$data['unique_id'] = $FNS->random('encrypt');
			$data['ip_address'] = '0.0.0.0';
			$data['join_date'] = $LOC->now; // TODO: option to get this from file

			// Do email address
			if ( !isset( $data['email'] ) || $data['email'] == '' ) {
				$data['email'] = $IN->GBL( "fallback_email" );
				$data['email'] = str_replace( "{row}", $count, $data['email']);
				$data['email'] = str_replace( "{username}", $data["username"], $data['email']);
			}

			$VAL = new Validate(
				array(
					'member_id'			=> '',
					'val_type'			=> 'new',
					'fetch_lang'		=> TRUE,
					'require_cpw'		=> FALSE,
					'enable_log'		=> FALSE,
					'cur_username'		=> '',
					'cur_screen_name'	=> '',
					'cur_password'		=> '',
					'cur_email'			=> '',
				)
			);
			
			$errors[$count] = "";
			
			$VAL->email = $data["email"];
			$VAL->username = $data["username"];
			$VAL->screen_name = $data["screen_name"];
			
			$VAL->validate_username();
			if ( isset($VAL->errors) && count($VAL->errors) > 0 )
			{
				foreach($VAL->errors as $key => $value)
				{
					$errors[$count] .= "<p>" . $value . " (" . $data["username"] . ")</p>";
				}
				unset($VAL->errors);
			}
			$VAL->validate_screen_name();
			if ( isset($VAL->errors) && count($VAL->errors) > 0 )
			{
				foreach($VAL->errors as $key => $value)
				{
					$errors[$count] .= "<p>" . $value . " (" . $data["screen_name"] . ")</p>";
				}
				unset($VAL->errors);
			}
			$VAL->validate_email();
			if ( isset($VAL->errors) && count($VAL->errors) > 0 )
			{
				foreach($VAL->errors as $key => $value)
				{
					$errors[$count] .= "<p>" . $value . " (" . $data["email"] . ")</p>";
				}
				unset($VAL->errors);
			}
			
			if( $errors[$count] != "" ) {
				continue;
			} else {
				unset( $errors[$count] );
			}
			

			if ( isset($data["password"]) ) {
				// Password is fetched from CSV file
				if( $plaintext == "y" ) {
					// Encrypt plain text password
					$data["password"] = $FNS->hash( $data["password"] );
				}
			} else {
				// Generate a password
				$password = $this->_generate_password();
				$data["password"] = $FNS->hash( $password );
				$item[] = $password;
				// OR: 
				// $data["password"] = $FNS->hash(mt_rand())
			}

			$sql = $DB->insert_string('exp_members', $data);
			//print "<p>" . $sql . "</p>";
			$DB->query( $sql );
	 		$member_id = $DB->insert_id;

			// Insert custom data into exp_member_data

			$data = array(
				"member_id" => $member_id
			);
			foreach( $member_data as $field => $mapping ) {
				$data[ $field ] = $item[ $mapping ];
			}
		
			$sql = $DB->insert_string('exp_member_data', $data);
			// print "<p>" . $sql . "</p>";
			$DB->query( $sql );
		
			$sql = $DB->insert_string( 'exp_member_homepage', 
				array(
					'member_id' => $member_id
				)
			);
			// print "<p>" . $sql . "</p>";
			$DB->query( $sql );
		
			$imported++;
		
			$output[] = $item;
		}
		
		if ( $skip == "y" ) { $count--; }
		
		$r = "";

		$DSP->title = $LANG->line('ajw_member_import_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=' . $this->module_name,
			$LANG->line('ajw_member_import_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Import members");    

		$DSP->right_crumb( "Documentation", "http://brandnewbox.co.uk/docs/");

		$DSP->crumbline = TRUE;

		$DSP->extra_header .= '<link rel="stylesheet" type="text/css" media="screen" href="/' . $PREFS->ini("system_folder", TRUE) . 'modules/ajw_member_import/css/ajw_member_import.css" ></link>';

		$r .= $this->_header( $LANG->line('ajw_member_import_module_name') );
		$r .= $this->_stepper();

		$r .= $DSP->form_open(
			array(
				'action' => 'C=modules'.AMP.'M='.$this->module_name.AMP.'P=results', 
				'enctype' => "multipart/form-data", 
				'name' => 'apply', 
				'id' => 'apply'
			)
		);

		$r .= $DSP->div("box") . 
			$DSP->qspan('defaultBold', $imported . " members successfully imported") .
			$DSP->div_c();
		
		$r .= $DSP->qdiv(
			'tableHeading', 
			"Errors"
		);

		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$i = 0;

		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->table_qcell($style, 
			$DSP->qspan('alert', "There are " . count( $errors ) . " errors")
		);
		$r .= $DSP->tr_c();

		foreach( $errors as $error ) {
			$r .= $DSP->tr();

			$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';

			$r .= $DSP->table_qcell($style, 
				$DSP->qspan('alert', "Error: " . $error)
			);

			$r .= $DSP->tr_c();
		}

		$r .= $DSP->table_c() . BR;

		$r .= $DSP->input_submit("Finish");

		$r .= $DSP->form_c();

		$DSP->body .= $r;
	}

	function results() {
		global $DB, $DSP, $LANG, $PREFS, $LOC, $IN, $FNS;

		// Handle input

		$r = "";

		$DSP->title = $LANG->line('ajw_member_import_module_name');
		$DSP->crumb = $DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=' . $this->module_name,
			$LANG->line('ajw_member_import_module_name'));

		$DSP->crumb .= $DSP->crumb_item("Results");    

		$DSP->right_crumb( "Documentation", "http://brandnewbox.co.uk/docs/");

		$DSP->crumbline = TRUE;

		$DSP->extra_header .= '<link rel="stylesheet" type="text/css" media="screen" href="/' . $PREFS->ini("system_folder", TRUE) . 'modules/ajw_member_import/css/ajw_member_import.css" ></link>';

		$r .= $this->_header( $LANG->line('ajw_member_import_module_name') );
		$r .= $this->_stepper();

		$r .= $DSP->qdiv(
			'tableHeading', 
			"Import complete"
		);

		$r .= $DSP->table('tableBorder', '0', '0', '100%');

		$i = 0;

		$r .= $DSP->tr();
		$style = (++$i % 2) ? 'tableCellOne' : 'tableCellTwo';
		$r .= $DSP->table_qcell($style, 
			$DSP->qdiv('defaultBold', BR . "If this module has saved you time, please consider making a donation. Many thanks.") . BR .
			'<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
			<input type="hidden" name="cmd" value="_s-xclick">
			<input type="hidden" name="hosted_button_id" value="9768629">
			<input type="image" src="https://www.paypal.com/en_GB/i/btn/btn_donate_SM.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online.">
			<img alt="" border="0" src="https://www.paypal.com/en_GB/i/scr/pixel.gif" width="1" height="1">
			</form>
			' . BR.
			$DSP->qdiv('alert', 
				$DSP->anchor(BASE.
					AMP.'C=admin'.
					AMP.'M=members'.
					AMP.'P=view_members',
					"View members")
			) . BR
		); 
		$r .= $DSP->tr_c();

		$r .= $DSP->table_c();


		$DSP->body .= $r;
	}

	function _header( $heading ) {
		global $DSP, $LANG;

		$r = $DSP->table('', '', '', '100%') .
			$DSP->tr() .
			$DSP->td('', '', '', '', 'top') .
			$DSP->heading( $heading ) .
			$DSP->td_c();

		$r .= $DSP->td_c() .
			$DSP->td('', '', '', '', 'top') .
			$DSP->div('defaultRight');

		$r .= '<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
			<input type="hidden" name="cmd" value="_s-xclick">
			<input type="hidden" name="hosted_button_id" value="9079601">
			<input type="image" src="http://brandnewbox.co.uk/res/v7/donate.png" border="0" name="submit" alt="PayPal - The safer, easier way to pay online.">
			<img alt="Please donate" border="0" src="https://www.paypal.com/en_GB/i/scr/pixel.gif" width="1" height="1">
			Please donate
			</form>
			';

		$r .= $DSP->div_c() . 
			$DSP->td_c() .
			$DSP->tr_c() .
			$DSP->table_c();


		return $r;
	}

	function _stepper() {
		global $DSP, $LANG, $IN;

		$steps = array(
			"home" => array("title" => "Select file"),
			"check_details" => array("title" => "Check details"),
			"map_fields" => array("title" => "Map member fields"),
			"import" => array("title" => "Import members"),
			"results" => array("title" => "Results"),
		);

		$r = $DSP->table('stepper', '', '', '100%') .
			$DSP->tr();
			
		/*
		$DSP->anchor(BASE.
			AMP.'C=modules'.
			AMP.'M=' . $this->module_name .
			AMP."P=" . $key, 
			$step["title"],
			'') .
		*/

		$do_link = FALSE;

		$count = 1;
		foreach( $steps as $key => $step ) {

			if ( $key == $IN->GBL("P") ) { $do_link = FALSE; }

			$class = "default";
			if( $key == $IN->GBL("P") ) {
				$class = 'default current';
			}
			if ( ($IN->GBL("P") == "") && $key == "home") { $class = "default current"; }
			if( $count == 1 ) {
				$class .= ' first';
			}
			if( $count == count( $steps ) ) {
				$class .= ' last';
			}

			$r .= $DSP->td( $class , '', '', '', 'middle') . 
				"<span>STEP " . $count++ . ". </span>";
			
			if ( $do_link ) {
				$r .= $DSP->anchor(BASE.
					AMP.'C=modules'.
					AMP.'M=' . $this->module_name .
					AMP."P=" . $key, 
					$step["title"],
					'');
			} else {
				$r .= $step["title"];
			}
		
			$r .= $DSP->td_c();
			
		}

		$r .= $DSP->tr_c() .
			$DSP->table_c();
			
		return $r;
	}

	/**
	 * Add $data to user session
	 *
	 * @param string $key 
	 * @param string $data 
	 * @return void
	 */
	function _set_session( $key, $data ) {
		@session_start();
		if ( !isset( $_SESSION[ $this->module_name ] ) ) {
			$_SESSION[ $this->module_name ] = array();
		}
		$_SESSION[ $this->module_name ][ $key ] = $data;
	}

	/**
	 * Retrieve data from session. Data is removed from session unless $keep is
	 * set to TRUE
	 *
	 * @param string $key 
	 * @param string $keep 
	 * @return void $data
	 */
	function _get_session( $key, $keep = FALSE ) {
		@session_start();  
		if( isset( $_SESSION[ $this->module_name ] ) ) {
			if( isset( $_SESSION[ $this->module_name ][ $key ] ) ) {
				$data = $_SESSION[ $this->module_name ][ $key ];
				if ( $keep != TRUE ) {
		    	unset($_SESSION[ $this->module_name ][ $key ]); 
		    	unset($_SESSION[ $this->module_name ]); 
				}
				return( $data );
			}
		}
		return "";
	}

	/**
	 * Generates a 'readable' password
	 *
	 * @return string password
	 */
	function _generate_password() {
		$length = 8;
		$conso=array("b","c","d","f","g","h","j","k","l",
	  "m","n","p","r","s","t","v","w","x","y","z");
	  $vocal=array("a","e","i","o","u");
	  $password="";
	  srand ((double)microtime()*1000000);
	  $max = $length/2;
	  for($i=1; $i<=$max; $i++)
	  {
	  $password.=$conso[rand(0,19)];
	  $password.=$vocal[rand(0,4)];
	  }
	  $newpass = $password;
	  return $newpass;
	}

	// ----------------------------------------
	//  Module installer
	// ----------------------------------------

	function ajw_member_import_module_install()
	{
		global $DB;

		// Install module

		$sql[] = "INSERT INTO exp_modules (
			module_id, 
			module_name,
			module_version,
			has_cp_backend
		) VALUES (
			'',
			'" . $this->module_name . "',
			'" . $this->version . "',
			'y'
			)";

		foreach ($sql as $query)
		{
			$DB->query($query);
		}

		return true;
	}
	// END    

	// ----------------------------------------
	//  Module de-installer
	// ----------------------------------------

	function ajw_member_import_module_deinstall()
	{
		global $DB;    

		$query = $DB->query("SELECT module_id FROM exp_modules WHERE module_name = '" . $this->module_name . "'"); 

		$sql[] = "DELETE FROM exp_module_member_groups 
			WHERE module_id = '".$query->row['module_id']."'";      

		$sql[] = "DELETE FROM exp_modules 
			WHERE module_name = '" . $this->module_name ."'";

		$sql[] = "DELETE FROM exp_actions 
			WHERE class = '" . $this->module_name . "'";

		$sql[] = "DELETE FROM exp_actions 
			WHERE class = '" . $this->module_name . "_CP'";

		foreach ($sql as $query)
		{
			$DB->query($query);
		}

		return true;
	}
	// END
}

/* End of file mcp.ajw_member_import.php */